NeuralEngine A Game Engine with embeded Machine Learning algorithms based on Gaussian Processes. |

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar > Class Template Reference

Base class with abstract and basic function definitions. All deep GP models will be derived from this class.
More...

`#include <FgGPLVMBaseModel.h>`

Inheritance diagram for NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >:
[legend]
Collaboration diagram for NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >:
[legend]

## Public Member Functions
| GPLVMBaseModel (const af::array &Y, int latentDimension, Scalar priorMean=0.0, Scalar priorVariance=1.0, LogLikType lType=LogLikType::Gaussian, XInit emethod=XInit::pca)
| Constructor. More...
| GPLVMBaseModel ()
| Default constructor. More...
virtual | ~GPLVMBaseModel ()
| Destructor. More...
virtual void | Optimise (OptimizerType method=L_BFGS, Scalar tol=0.0, bool reinit_hypers=true, int maxiter=1000, int mb_size=0, LineSearchType lsType=MoreThuente, bool disp=true, int *cycle=nullptr) override
| Optimizes the model parameters for best fit. More...
virtual bool | Init (af::array &mx)
| Initializes the model. More...
virtual bool | Init () override
| Initializes the model. More...
virtual void | PosteriorLatents (af::array &mx, af::array &vx)
| Get posterior distribution of latent variables /f$\mathbf{X}/f$. More...
virtual int | GetNumParameters () override
| Gets number of parameters. More...
virtual void | SetParameters (const af::array &param) override
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters () override
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters () override
| Updates the parameters. More...
virtual void | FixKernelParameters (bool isfixed)
| Sets fixation for hyperparameters. More...
virtual void | FixInducing (bool isfixed)
| Set fixation for inducing inputs. More...
void | FixLatents (bool isFixed)
af::array | GetMeanGradient ()
| Gets prior mean gradient. More...
af::array | GetVarGradient ()
| Gets prior variance gradient. More...
void | SetPrior (const af::array mean, const af::array var)
| Sets the prior. More...
void | SetPriorCavity (const af::array meanCav, const af::array varCav)
| Sets the cavity prior. More...
void | SetLatentGradient (const af::array &dmParent, const af::array &dvParent)
| Sets latent gradient. More...
void | SetLatentGradientCavity (const af::array &dmParent, const af::array &dvParent)
| Sets the latent cavity gradient. More...
int | GetLatentDimension ()
| Gets latent dimension. More...
void | SetBackConstraint (IBackconstraint< Scalar > *constraint)
| Sets a back-constraint. More...
IBackconstraint< Scalar > * | GetBackConstraint ()
| Gets the back-constraint. More...
void | SetStyles (std::map< std::string, Style< Scalar > > *styles)
| Sets the syles. More...
void | AddStyle (Style< Scalar > style)
| Adds a style. More...
std::map< std::string, Style< Scalar > > * | GetStyles ()
| Gets the styles. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >
| GPBaseModel (const af::array &Y, LogLikType lType=LogLikType::Gaussian, ModelType mtype=ModelType::GPR)
| Constructor. More...
| GPBaseModel ()
| Default Constructor. More...
virtual | ~GPBaseModel ()
| Destructor. More...
virtual void | Optimise (OptimizerType method=L_BFGS, Scalar tol=0.0, bool reinit_hypers=true, int maxiter=1000, int mb_size=0, LineSearchType lsType=MoreThuente, bool disp=true, int *cycle=nullptr)
| Optimizes the model parameters for best fit. More...
virtual bool | Init ()
| Initializes the model. More...
virtual void | PredictF (const af::array &testInputs, af::array &mf, af::array &vf)
| Predict noise free functions values \(\mathbf{F}_*\). More...
virtual void | PredictY (const af::array &testInputs, af::array &my, af::array &vy)
| Prediction of test outputs \(\mathbf{Y}_*\). More...
virtual void | SampleY (const af::array inputs, int numSamples, af::array &outFunctions)
| Generate function samples from posterior. More...
virtual void | AddData (const af::array Ytrain)
| Adds training data to the model. More...
af::array | GetTrainingData ()
| Gets the training data set Y. More...
void | SetTrainingData (af::array &data)
| Sets training data Y. More...
virtual int | GetNumParameters ()
| Gets number of parameters. More...
virtual void | SetParameters (const af::array &param)
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters ()
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters ()
| Updates the parameters. More...
virtual void | FixLikelihoodParameters (bool isfixed)
| Sets the likelihood parameters to be fixed or not for optimization. More...
void | SetSegments (af::array segments)
| Sets fixation for hyperparameters. More...
af::array | GetSegments ()
| Gets the start index array for the sequences. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::IModel< Scalar >
virtual Scalar | Function (const af::array &x, af::array &outGradient)
| Cost function the given x inputs. More...
virtual int | GetNumParameters ()=0
| Gets number of parameters to be optimized. More...
virtual void | SetParameters (const af::array &param)=0
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters ()=0
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters ()=0
| Updates the parameters. More...
int | GetDataLenght ()
| Gets data lenght. More...
int | GetDataDimensionality ()
| Gets data dimensionality. More...
ModelType | GetModelType ()
| Gets model type. More...
virtual void | SetBatchSize (int size)
| Sets batch size. More...
int | GetBatchSize ()
| Gets batch size. More...
void | SetIndexes (af::array &indexes)
| Sets the batch indexes. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::GPNode< Scalar >
| GPNode ()
| Default constructor. More...
virtual | ~GPNode ()
| Destructor. More...
int | GetNumChildren () const
| Gets the number of children of this item. More...
int | AttachChild (std::shared_ptr< GPNode< Scalar > > const &child)
| Attaches a child. More...
int | DetachChild (std::shared_ptr< GPNode< Scalar > > const &child)
| Detaches a child. More...
std::shared_ptr< GPNode< Scalar > > | DetachChildAt (int i)
| Detaches a child at index. More...
void | DetachAllChildren ()
| Detach all children from this node. More...
std::shared_ptr< GPNode< Scalar > > | SetChild (int i, std::shared_ptr< GPNode< Scalar > > const &child)
| Sets a child. More...
std::shared_ptr< GPNode< Scalar > > | GetChild (int i)
| Gets a child at index. More...
GPNode< Scalar > * | GetParent ()
| Access to the parent object, which is null for the root of the hierarchy. More...
void | SetParent (GPNode< Scalar > *parent)
| Access to the parent object. Node calls this during attach/detach of children. More...

## Protected Member Functions
virtual af::array | PosteriorGradientLatents (const af::array &dmx, const af::array &dvx)
| Posterior gradient of latent inputs /f$\mathbf{X}/f$. More...
virtual void | UpdateParametersInternal ()
| Updates the internal parameters. More...
virtual af::array | LatentGradient (const af::array &dm, const af::array &dv)
| Latent gradient. More...
Protected Member Functions inherited from NeuralEngine::MachineLearning::IModel< Scalar >
| IModel (int numData, int numDimension, ModelType type)
| Constructor. More...

## Protected Attributes
int | iq
| latent dimension More...
Scalar | dPriorMean
| prior mean More...
Scalar | dPriorVariance
| prior variance More...
Scalar | dPriorX1
| prior /f$x_1/f$ More...
Scalar | dPriorX2
| prior /f$x_2/f$ More...
af::array | afFactorX1
| natural parameter factor 1 for latent variable More...
af::array | afFactorX2
| natural parameter factor 2 for latent variable More...
af::array | afPosteriorX1
| posterior natural parameter 1 for latent variable More...
af::array | afPosteriorX2
| posterior natural parameter 2 for latent variable More...
af::array | afPriorMean
| prior mean for hiersrchy mode More...
af::array | afPriorVariance
| prior variance for hiersrchy mode More...
af::array | afPriorMeanCav
| prior mean for hiersrchy mode More...
af::array | afPriorVarianceCav
| prior variance for hiersrchy mode More...
af::array | afPriorX1
| prior /f$x_1/f$ More...
af::array | afPriorX2
| prior /f$x_2/f$ More...
af::array | afPriorX1Cav
| prior /f$x_1/f$ More...
af::array | afPriorX2Cav
| prior /f$x_2/f$ More...
af::array | afGradMean
| prior mean gradient for hiersrchy mode More...
af::array | afGradVariance
| prior variance gradient for hiersrchy mode More...
af::array | afGradMeanCav
| prior mean gradient for hiersrchy mode More...
af::array | afGradVarianceCav
| prior variance gradient for hiersrchy mode More...
af::array | afLatentGradientX
| top down gradient More...
XInit | eEmMethod
IBackconstraint< Scalar > * | backConst
| back-constraint More...
std::map< std::string, Style< Scalar > > * | mStyles
| style variable More...
bool | bIsLatetsFixed
Protected Attributes inherited from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >
bool | bInit
| check if model is initialized More...
af::array | afY
| training dataset, mean substracted More...
af::array | afBias
| the bias More...
af::array | afSegments
| Index of starting positions for all trials. More...
LikelihoodBaseLayer< Scalar > * | likLayer
| liklihood layer More...
Protected Attributes inherited from NeuralEngine::MachineLearning::IModel< Scalar >
ModelType | mType
int | iN
| dataset length More...
int | iD
| dataset dimension More...
int | iBatchSize
| size of the batch More...
af::array | afIndexes
| indexes of /f$\mathbf{X}/f$ for batch learning More...
af::dtype | m_dType
| floating point precision flag for af::array More...
Protected Attributes inherited from NeuralEngine::MachineLearning::GPNode< Scalar >
std::vector< std::shared_ptr< GPNode< Scalar > > > | mChild
GPNode< Scalar > * | mParent

## Private Member Functions
template<class Archive >
void | serialize (Archive &ar, unsigned int version)

## Friends
class | boost::serialization::access
class | KBR< Scalar >
class | PTC< Scalar >

## Detailed Description

template<typename Scalar>
class NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >

Base class with abstract and basic function definitions. All deep GP models will be derived from this class.

HmetalT, 26.10.2017.

Definition at line 294 of file FgGPLVMBaseModel.h.

## Constructor & Destructor Documentation

## ◆ GPLVMBaseModel() [1/2]

template<typename Scalar >

NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GPLVMBaseModel | ( | const af::array & | Y,
|  | int | latentDimension,
|  | Scalar | priorMean = `0.0`,
|  | Scalar | priorVariance = `1.0`,
|  | LogLikType | lType = `LogLikType::Gaussian`,
|  | XInit | emethod = `XInit::pca`
| ) |  |

Constructor.

, 26.03.2018.

Parameters

  Y | The data af::array to process.
  latentDimension | The training inputs.
  priorMean | (Optional) The description for one hidden layer.
  priorVariance | (Optional) The prior variance.
  numInducing | (Optional) Number of inducings.
  lType | (Optional) the loglik type.
  emethod | (Optional) The emethod.

## ◆ GPLVMBaseModel() [2/2]

template<typename Scalar >

NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GPLVMBaseModel | ( |  | ) |

Default constructor.

Hmetal T, 31/03/2020.

## ◆ ~GPLVMBaseModel()

template<typename Scalar >

virtual NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::~GPLVMBaseModel | ( |  | ) |
| virtual

Destructor.

, 15.05.2018.

## Member Function Documentation

## ◆ Optimise()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::Optimise | ( | OptimizerType | method = `L_BFGS`,
|  | Scalar | tol = `0.0`,
|  | bool | reinit_hypers = `true`,
|  | int | maxiter = `1000`,
|  | int | mb_size = `0`,
|  | LineSearchType | lsType = `MoreThuente`,
|  | bool | disp = `true`,
|  | int * | cycle = `nullptr`
| ) |  |
| override virtual

Optimizes the model parameters for best fit.

Hmetal T, 29.11.2017.

Parameters

  method | (Optional) the optimization method.
  tol | (Optional) the tolerance.
  reinit_hypers | (Optional) true to re hypers.
  maxiter | (Optional) max iterations.
  mb_size | (Optional) batch size.
  LSType | (Optional) linesearch type.
  disp | (Optional) true to disp.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

## ◆ Init() [1/2]

template<typename Scalar >

virtual bool NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::Init | ( | af::array & | mx | ) |
| virtual

Initializes the model.

Hmetal T, 29.11.2017.

Returns
  true if it succeeds, false if it fails.

## ◆ Init() [2/2]

template<typename Scalar >

virtual bool NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::Init | ( |  | ) |
| override virtual

Initializes the model.

Hmetal T, 29.11.2017.

Returns
  true if it succeeds, false if it fails.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ PosteriorLatents()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::PosteriorLatents | ( | af::array & | mx,
|  | af::array & | vx
| ) |  |
| virtual

Get posterior distribution of latent variables /f$\mathbf{X}/f$.

Hmetal T, 09/12/2019.

Parameters

  index | Index of selected inputs.
  mx | [in,out] The mean.
  vx | [in,out] The variance.

## ◆ GetNumParameters()

template<typename Scalar >

virtual int NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetNumParameters | ( |  | ) |
| override virtual

Gets number of parameters.

, 26.06.2018.

Returns
  The number parameters.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ SetParameters()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetParameters | ( | const af::array & | param | ) |
| override virtual

Sets the parameters for each optimization iteration.

, 26.06.2018.

Parameters

  param | The parameter.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ GetParameters()

template<typename Scalar >

virtual af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetParameters | ( |  | ) |
| override virtual

Gets the parameters for each optimization iteration.

, 26.06.2018.

Parameters

  param | The parameter.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ UpdateParameters()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::UpdateParameters | ( |  | ) |
| override virtual

Updates the parameters.

, 26.06.2018.

Reimplemented from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ FixKernelParameters()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::FixKernelParameters | ( | bool | isfixed | ) |
| virtual

Sets fixation for hyperparameters.

Hmetal T, 16/12/2019.

Parameters

  isfixed | True if isfixed.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseDeepGPLVMBaseModel< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ FixInducing()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::FixInducing | ( | bool | isfixed | ) |
| virtual

Set fixation for inducing inputs.

Hmetal T, 16/12/2019.

Parameters

  isfixed | True if isfixed.

Reimplemented in NeuralEngine::MachineLearning::GPModels::SparseGPLVMBaseModel< Scalar >.

## ◆ GetMeanGradient()

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetMeanGradient | ( |  | ) |

Gets prior mean gradient.

Hmetal T, 31/08/2020.

Returns
  The mean gradient.

## ◆ GetVarGradient()

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetVarGradient | ( |  | ) |

Gets prior variance gradient.

Hmetal T, 31/08/2020.

Returns
  The variable gradient.

## ◆ SetPrior()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetPrior | ( | const af::array | mean,
|  | const af::array | var
| ) |  |

Sets the prior.

Hmetal T, 01/09/2020.

Parameters

  mean | The mean.
  var | The variable.

## ◆ SetPriorCavity()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetPriorCavity | ( | const af::array | meanCav,
|  | const af::array | varCav
| ) |  |

Sets the cavity prior.

Hmetal T, 20/04/2021.

Parameters

  meanCav | The mean cav.
  varCav | The variable cav.

## ◆ SetLatentGradient()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetLatentGradient | ( | const af::array & | dmParent,
|  | const af::array & | dvParent
| ) |  |

Sets latent gradient.

Hmetal T, 20/04/2021.

Parameters

  dmParent | The dm parent.
  dvParent | The dv parent.

## ◆ SetLatentGradientCavity()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetLatentGradientCavity | ( | const af::array & | dmParent,
|  | const af::array & | dvParent
| ) |  |

Sets the latent cavity gradient.

Hmetal T, 20/04/2021.

Parameters

  dmParent | The dm parent.
  dvParent | The dv parent.

## ◆ GetLatentDimension()

template<typename Scalar >

int NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetLatentDimension | ( |  | ) |

Gets latent dimension.

Hmetal T, 01/09/2020.

Returns
  The latent dimension.

## ◆ SetBackConstraint()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetBackConstraint | ( | IBackconstraint< Scalar > * | constraint | ) |

Sets a back-constraint.

Hmetal T, 17/09/2020.

Parameters

  constraint | The constraint.

## ◆ GetBackConstraint()

template<typename Scalar >

IBackconstraint< Scalar > * NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetBackConstraint | ( |  | ) |

Gets the back-constraint.

Hmetal T, 17/09/2020.

Returns
  Null if it fails, else the back constraint.

## ◆ SetStyles()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::SetStyles | ( | std::map< std::string, Style< Scalar > > * | styles | ) |

Sets the syles.

Hmetal T, 25/09/2020.

Parameters

  styles | [in,out] If non-null, the styles.

## ◆ AddStyle()

template<typename Scalar >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::AddStyle | ( | Style< Scalar > | style | ) |

Adds a style.

Hmetal T, 02/11/2020.

Parameters

  styles | The styles.

## ◆ GetStyles()

template<typename Scalar >

std::map< std::string, Style< Scalar > > * NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::GetStyles | ( |  | ) |

Gets the styles.

Hmetal T, 25/09/2020.

Returns
  Null if it fails, else the styles.

## ◆ PosteriorGradientLatents()

template<typename Scalar >

virtual af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::PosteriorGradientLatents | ( | const af::array & | dmx,
|  | const af::array & | dvx
| ) |  |
| protected virtual

Posterior gradient of latent inputs /f$\mathbf{X}/f$.

Hmetal T, 09/12/2019.

Parameters

  dmx | [in,out] The gradient of the mean.
  dvx | [in,out] The the gradient of the variance.

## ◆ UpdateParametersInternal()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::UpdateParametersInternal | ( |  | ) |
| protected virtual

Updates the internal parameters.

Hmetal T, 23/03/2020.

## ◆ LatentGradient()

template<typename Scalar >

virtual af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::LatentGradient | ( | const af::array & | dm,
|  | const af::array & | dv
| ) |  |
| protected virtual

Latent gradient.

Hmetal T, 20/04/2021.

Returns
  An af::array.

## ◆ serialize()

template<typename Scalar >
template<class Archive >

void NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::serialize | ( | Archive & | ar,
|  | unsigned int | version
| ) |  |
| inline private

Definition at line 615 of file FgGPLVMBaseModel.h.

## Friends And Related Function Documentation

## ◆ boost::serialization::access

template<typename Scalar >

friend class boost::serialization::access
| friend

Definition at line 610 of file FgGPLVMBaseModel.h.

## ◆ KBR< Scalar >

template<typename Scalar >

friend class KBR< Scalar >
| friend

Definition at line 610 of file FgGPLVMBaseModel.h.

## ◆ PTC< Scalar >

template<typename Scalar >

friend class PTC< Scalar >
| friend

Definition at line 610 of file FgGPLVMBaseModel.h.

## Member Data Documentation

## ◆ iq

template<typename Scalar >

int NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::iq
| protected

latent dimension

Definition at line 575 of file FgGPLVMBaseModel.h.

## ◆ dPriorMean

template<typename Scalar >

Scalar NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::dPriorMean
| protected

prior mean

Definition at line 577 of file FgGPLVMBaseModel.h.

## ◆ dPriorVariance

template<typename Scalar >

Scalar NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::dPriorVariance
| protected

prior variance

Definition at line 578 of file FgGPLVMBaseModel.h.

## ◆ dPriorX1

template<typename Scalar >

Scalar NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::dPriorX1
| protected

prior /f$x_1/f$

Definition at line 579 of file FgGPLVMBaseModel.h.

## ◆ dPriorX2

template<typename Scalar >

Scalar NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::dPriorX2
| protected

prior /f$x_2/f$

Definition at line 580 of file FgGPLVMBaseModel.h.

## ◆ afFactorX1

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afFactorX1
| protected

natural parameter factor 1 for latent variable

Definition at line 582 of file FgGPLVMBaseModel.h.

## ◆ afFactorX2

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afFactorX2
| protected

natural parameter factor 2 for latent variable

Definition at line 583 of file FgGPLVMBaseModel.h.

## ◆ afPosteriorX1

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPosteriorX1
| protected

posterior natural parameter 1 for latent variable

Definition at line 584 of file FgGPLVMBaseModel.h.

## ◆ afPosteriorX2

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPosteriorX2
| protected

posterior natural parameter 2 for latent variable

Definition at line 585 of file FgGPLVMBaseModel.h.

## ◆ afPriorMean

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorMean
| protected

prior mean for hiersrchy mode

Definition at line 587 of file FgGPLVMBaseModel.h.

## ◆ afPriorVariance

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorVariance
| protected

prior variance for hiersrchy mode

Definition at line 588 of file FgGPLVMBaseModel.h.

## ◆ afPriorMeanCav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorMeanCav
| protected

prior mean for hiersrchy mode

Definition at line 589 of file FgGPLVMBaseModel.h.

## ◆ afPriorVarianceCav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorVarianceCav
| protected

prior variance for hiersrchy mode

Definition at line 590 of file FgGPLVMBaseModel.h.

## ◆ afPriorX1

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorX1
| protected

prior /f$x_1/f$

Definition at line 591 of file FgGPLVMBaseModel.h.

## ◆ afPriorX2

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorX2
| protected

prior /f$x_2/f$

Definition at line 592 of file FgGPLVMBaseModel.h.

## ◆ afPriorX1Cav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorX1Cav
| protected

prior /f$x_1/f$

Definition at line 593 of file FgGPLVMBaseModel.h.

## ◆ afPriorX2Cav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afPriorX2Cav
| protected

prior /f$x_2/f$

Definition at line 594 of file FgGPLVMBaseModel.h.

## ◆ afGradMean

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afGradMean
| protected

prior mean gradient for hiersrchy mode

Definition at line 595 of file FgGPLVMBaseModel.h.

## ◆ afGradVariance

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afGradVariance
| protected

prior variance gradient for hiersrchy mode

Definition at line 596 of file FgGPLVMBaseModel.h.

## ◆ afGradMeanCav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afGradMeanCav
| protected

prior mean gradient for hiersrchy mode

Definition at line 597 of file FgGPLVMBaseModel.h.

## ◆ afGradVarianceCav

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afGradVarianceCav
| protected

prior variance gradient for hiersrchy mode

Definition at line 598 of file FgGPLVMBaseModel.h.

## ◆ afLatentGradientX

template<typename Scalar >

af::array NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::afLatentGradientX
| protected

top down gradient

Definition at line 600 of file FgGPLVMBaseModel.h.

## ◆ eEmMethod

template<typename Scalar >

XInit NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::eEmMethod
| protected

Definition at line 602 of file FgGPLVMBaseModel.h.

## ◆ backConst

template<typename Scalar >

IBackconstraint<Scalar>* NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::backConst
| protected

back-constraint

Definition at line 604 of file FgGPLVMBaseModel.h.

## ◆ mStyles

template<typename Scalar >

std::map<std::string, Style<Scalar> >* NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::mStyles
| protected

style variable

Definition at line 605 of file FgGPLVMBaseModel.h.

## ◆ bIsLatetsFixed

template<typename Scalar >

bool NeuralEngine::MachineLearning::GPModels::GPLVMBaseModel< Scalar >::bIsLatetsFixed
| protected

Definition at line 607 of file FgGPLVMBaseModel.h.

The documentation for this class was generated from the following file:

- FgGPLVMBaseModel.h